/////////////////////////////////////////////////////////////////////
//
//	Applied Data Systems, Inc
//
//  InitRegistry.cpp : 
//
//  This driver reads Registry file from OnBoardFlash abd initialised 
//  system Registry.
//
//	02.24.99	
//
//////////////////////////////////////////////////////////////////////

//#include <bceddk.h>
//#include <sa1100.h>
#include "ADSfile.h"
#include "ADSparse.h"


#define __EXPORT __declspec(dllexport) 



// This is the only active function REG driver.
// Function reads Registry information from OnBoardFlash and set up the Registry
__EXPORT HANDLE REG_Init( ULONG   RegistryPath )

{

    CADSFileOnBoardFlash RegF("???");
    CADSparse  ParseF(&RegF);

    HKEY    hDrvKey, hDevDrvKey;
    DWORD   RegParSize;
    TCHAR   RegClass[128];
    TCHAR   DevKeyName[256];
    LONG    RegistryReturn;
	ULONG 	ShowBuildDate=0;

	// open developer registry path
    //
    // Locate this drivers registry entries from the passed in key
    // Open the key as active
    //
    RegistryReturn = RegOpenKeyEx(	HKEY_LOCAL_MACHINE,
									(LPCWSTR)RegistryPath,
									0,
									KEY_ALL_ACCESS,
									&hDevDrvKey);

	if (RegistryReturn != ERROR_SUCCESS) 
	{
        RETAILMSG(1,(L" REG_Init : hDevDrvKey failed to open %d\r\n", RegistryReturn));
        return 0;
	}
    
	// read developer registry path

    RegParSize = sizeof(DevKeyName);

    if ((RegistryReturn = RegQueryValueEx(	hDevDrvKey,
                        					TEXT("Key"),
                        					0,
                        					(LPDWORD)RegClass,
                        					(LPBYTE)DevKeyName,
                        					&RegParSize)) != ERROR_SUCCESS)
	
	{
        RETAILMSG(1,(L" REG_Init : %s failed  = %d\r\n", TEXT("Key"), RegistryReturn));
        return 0;
    }

    RegCloseKey (hDevDrvKey);


    //
    // Locate this drivers registry entries from the passed in key
    // Open the key as active
    //
    RegistryReturn = RegOpenKeyEx(	HKEY_LOCAL_MACHINE,
									DevKeyName,
									0,
									KEY_ALL_ACCESS,
									&hDrvKey);

	if (RegistryReturn != ERROR_SUCCESS) 
	{
        RETAILMSG(1,(L" REG_Init : hDrvKey failed to open %d\r\n", RegistryReturn));
        return 0;
	}

    RegParSize = sizeof(DWORD);
    RegistryReturn = RegQueryValueEx(	hDrvKey,
                        				L"ShowBuildDate",
                        				0,
                        				(LPDWORD)RegClass,
                        				(LPBYTE)&ShowBuildDate,
                        				&RegParSize);
	
    RegCloseKey(hDrvKey);

	if(ShowBuildDate)
	{
   		RETAILMSG(1,(L"\r\n REG : Build at %hs on %hs. \r\n", __TIME__, __DATE__));	
	}

    //
    // Now get configuration information path from the acquired ActiveKey.
    // If its good open the key
    //

	//RETAILMSG(TRUE,(L"REG_Init:Start!!! \r\n"));
	
    CKeyEntry *pKeyEntr = ParseF.ParseFile();

    if (!pKeyEntr)
    {
        RETAILMSG(TRUE,(L"REG_Init::ParseF.ParseFile() failed\r\n"));
    }

    BOOL bRet = ParseF.UpdateRegistry(pKeyEntr);
    if (!bRet)
    {
        RETAILMSG(TRUE,(L"REG_Init::ParseF.UpdateRegistry() failed\r\n"));
    }

	//RETAILMSG(TRUE,(L"REG_Init:Done!!! \r\n"));
	
	return REG_Init;
}

__EXPORT BOOL	REG_Deinit(DWORD pvFlashDC)
{
    return TRUE;
}

__EXPORT HANDLE  REG_Open(DWORD  pFlashDC,        // @parm Handle returned by REG_Init.
        		 DWORD   AccessCode,     // @parm access code.
        		 DWORD   ShareMode)      // @parm share mode - Not used in this driver.
{
	return NULL;
}

__EXPORT BOOL	REG_Close(DWORD pOpenContext)
{
	return TRUE;
}

__EXPORT ULONG	REG_Read(
        	DWORD       pOpenContext,   //@parm [IN]	 HANDLE returned by REG_Open   
	        PUCHAR      pTargetBuffer,  //@parm [IN,OUT] Pointer to valid memory.	  
    	    ULONG       BufferLength    //@parm [IN]	 Size in bytes of pTargetBuffer.
        	)
{
    return 0;
}

__EXPORT ULONG	REG_Write(
          DWORD pOpenContext,           /*@parm [IN]  HANDLE returned by REG_Open.*/
          PUCHAR pSourceBytes,  		/*@parm [IN]  Pointer to bytes to be written.*/
          ULONG  NumberOfBytes  		/*@parm [IN]  Number of bytes to be written. */
         )
{
    return 0;
}
	

__EXPORT DWORD	REG_Seek(
        DWORD   pOpenContext, 
        LONG    Position,
        DWORD   Type
        )
{
    return 0;
}


__EXPORT BOOL  REG_IOControl(
    DWORD Handle, 
    DWORD Code, 
    PBYTE BufIn, 
    DWORD LenIn, 
    PBYTE BufOut, 
    DWORD LenOut, 
    PDWORD ActOut)
{
    return(TRUE);
}

__EXPORT VOID  REG_PowerDown(
    DWORD DeviceContext)
{
}

__EXPORT VOID  REG_PowerUp(
    DWORD DeviceContext)
{
}



